/*
 * Copyright (C) 2008  Intel Corporation
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License, version 2.1, as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <UserSession.h>
#include <stdio.h>

int main()
{
	int result = 0;
	UserSessionStatus status;
	
	result = InitializeUserSessionStatus();
	if (result != 0) {
		printf("initialize fialed!\n");
		return 1;
	}

	status = GetUserSessionStatus();
	switch (status) {
	case USS_ActiveSession:
		printf("Session is active!\n");
		break;
	case USS_ActiveRemoteSession:
		printf("Remote session is active!\n");
		break;
	case USS_InactiveSession:
		printf("Session is inactive!\n");
		break;
	case USS_Uninitialized:
		printf("The library is not uninitialized!\n");
		break;
	default:
		printf("Known error!\n");
	}

	UninitializeUserSessionStatus();

	return 0;
}
