/****************************************************************************

Copyright (c) Intel Corporation (2008).

DISCLAIMER OF WARRANTY
NEITHER INTEL NOR ITS SUPPLIERS MAKE ANY REPRESENTATION OR WARRANTY OR
CONDITION OF ANY KIND WHETHER EXPRESS OR IMPLIED (EITHER IN FACT OR BY
OPERATION OF LAW) WITH RESPECT TO THE SOURCE CODE.  INTEL AND ITS SUPPLIERS
EXPRESSLY DISCLAIM ALL WARRANTIES OR CONDITIONS OF MERCHANTABILITY OR
FITNESS FOR A PARTICULAR PURPOSE.  INTEL AND ITS SUPPLIERS DO NOT WARRANT
THAT THE SOURCE CODE IS ERROR-FREE OR THAT OPERATION OF THE SOURCE CODE WILL
BE SECURE OR UNINTERRUPTED AND HEREBY DISCLAIM ANY AND ALL LIABILITY ON
ACCOUNT THEREOF.  THERE IS ALSO NO IMPLIED WARRANTY OF NON-INFRINGEMENT.
SOURCE CODE IS LICENSED TO LICENSEE ON AN "AS IS" BASIS AND NEITHER INTEL
NOR ITS SUPPLIERS WILL PROVIDE ANY SUPPORT, ASSISTANCE, INSTALLATION,
TRAINING OR OTHER SERVICES.  INTEL AND ITS SUPPLIERS WILL NOT PROVIDE ANY
UPDATES, ENHANCEMENTS OR EXTENSIONS.

File Name:          PMDriverMgmt.h

Description:

    This file defines class PMDriverMgmt.

Environment (opt):

    OS: Ubuntu
    SE: Code::Block

Notes (opt):

  =====================================================================

  Revision   Revision History               Author     Date

  =====================================================================

  0.1        Create                         Deng Jing 2008-8-15

  =====================================================================

****************************************************************************/

#ifndef PMDRIVERMGMT_H_INCLUDED
#define PMDRIVERMGMT_H_INCLUDED

#include "PMDriver.h"

#include <iostream>
using namespace std;

class PMDriverMgmt
{
public:
    static PMDriverMgmt* Getinstance();
    int InitializeDriverPath();

    int GetBrightness();
    int SetBrightness(int value);

    int GetWireless();
    int SetWireless(int value);

    int GetLan();
    int SetLan(int value);

    ~PMDriverMgmt();

protected:
    PMDriverMgmt();

private:
    void GetDriverPath();

private:
    static PMDriverMgmt* m_pPMDriverMgmt;
    static char m_pDriverPath[ACPI_MAX_STRING];
    int m_fd;
};


#endif // PMDRIVERMGMT_H_INCLUDED
