/*
* Copyright (C) 2008  Intel Corporation
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License, version 2, as
* published by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License along
* with this program; if not, write to the Free Software Foundation, Inc.,
* 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*
* In addition, as a special exception, Intel gives permission to link
* the code of portions of this program with the OpenSSL project's
* "OpenSSL" library (or with modified versions of it that use the same
* license as the "OpenSSL" library), and distribute the linked
* executables.  You must obey the GNU General Public License in all
* respects for all of the code used other than "OpenSSL".  If you modify
* this file, you may extend this exception to your version of the file,
* but you are not obligated to do so.  If you do not wish to do so,
* delete this exception statement from your version.
*/

#include <pwd.h>
#include <fstream>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <sys/stat.h>
using namespace std;

int main()
{
   	FILE *pf=NULL;
	char pwd_path[PATH_MAX];
	memset(pwd_path, 0, PATH_MAX);

    struct passwd* pwd = getpwuid(getuid());
	strcpy(pwd_path, pwd->pw_dir);
	strcat(pwd_path,"/.dcs");

	time_t ltime;

	struct   stat   s;  
    if(lstat(pwd_path,   &s)   <   0){  
		mkdir(pwd_path, 0777);
	}  
    strcat(pwd_path, "/passwd");
     if(lstat(pwd_path,   &s)   >=   0){  
       	return 0;
	 }  

    if( (pf=fopen(pwd_path, "w")) == NULL)
	{
		printf("can't create file %s.\n", pwd_path );
		exit(1);
	}

	time( &ltime );
	srand( (int)ltime & 0x00000000FFFFFFFF);
	for(int i=0; i<32; i++)
	{
		fprintf(pf, "%c", rand()%26 + 'A'); //rand()%26 + 'A'
	}

	fclose(pf);
    return 0;
}
